// Please retain this next 10 lines
//This softwre is FREE!!  Open Source software, do what you want with it, open to the community, etc.....
// GNU General Public License
// see http://www.gnu.org/licenses/gpl-2.0.html

//The only thing I ask is that if you find an error or nice addition, 
//that you post the modified source on the Mediachance message boards or contact me
//andydansby so I can modify the code.

// written by Andy Dansby, not Copyrighted, OPEN SOURCE

// plugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "IPlugin.h"

#include <math.h>// for Math Functions
#include <stdio.h>// for output Functions including messagebox

////////////////////////////////////////////////////////////////////////
// A concrete plugin implementation
////////////////////////////////////////////////////////////////////////

// Photo-Reactor Plugin class

//****************************************************************************
//This code has been generated by the Mediachance photo reactor Code generator.


#define AddParameter(N,S,V,M1,M2,T,D) {strcpy (pParameters[N].m_sLabel,S);pParameters[N].m_dValue = V;pParameters[N].m_dMin = M1;pParameters[N].m_dMax = M2;pParameters[N].m_nType = T;pParameters[N].m_dSpecialValue = D;}

#define GetValue(N) (pParameters[N].m_dValue)
#define GetValueY(N) (pParameters[N].m_dSpecialValue)

#define SetValue(N,V) {pParameters[N].m_dValue = V;}

#define GetBOOLValue(N) ((BOOL)(pParameters[N].m_dValue==pParameters[N].m_dMax))

// if it is not defined, then here it is
//#define RGB(r,g,b) ((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))




#define PARAM_WHITEBALANCE	0


#define NUMBER_OF_USER_PARAMS 1

class PluginTest : public IPlugin	
{
public:




	// constructor
	PluginTest()
	{



	}


		//Plugin Icon:
	//you can add your own icon by creating 160x100 png file, naming it the same as plugin dll and then placing it in the plugins folder
	//otherwise a generic icon will be used 

	//this is the title of the box in workspace. it should be short
	const char* GetTitle () const
	{
		return "White Balance";
	}
	
	// this will appear in the help pane, you can put your credits and short info
	const char* GetDescription () const
	{
		return "Various approaches to perform White Balance. Open Source software written by Andy Dansby";
	}

	// BASIC PARAMETERS
	// number of inputs 0,1 or 2
	int GetInputNumber ()
	{
		return 1;
	}

	// number of outputs 0 or 1
	int GetOutputNumber ()
	{
		return 1;
	}

	int GetBoxColor ()
	{
		return RGB(56,61,72);
	}

	int GetTextColor ()
	{
		return RGB(130,130,130);
	}

	// width of the box in the workspace
	// valid are between 50 and 100
	int GetBoxWidth ()
	{
		return 90;
	}

	// set the flags
	// see the interface builder
	// ex: nFlag = FLAG_FAST_PROCESS | FLAG_HELPER;

	//FLAG_NONE same as zero	Default, no other flags set
	//FLAG_UPDATE_IMMEDIATELY	It is very fast process that can update immediately. When user turns the sliders on UI the left display will update
	//							Use Update Immediately only for fast and single loop processes, for example Desaturate, Levels.
	//FLAG_HELPER				It is an helper object. Helper objects will remain visible in Devices and they can react to mouse messages. Example: Knob, Monitor, Bridge Pin
	//FLAG_BINDING				Binding object, attach to other objects and can change its binding value. It never goes to Process_Data functions.  Example: Knob, Switch, Slider
	//FLAG_DUMMY				It is only for interface but never process any data. Never goes to Process_Data functions. Example: Text note
	//FLAG_SKIPFINAL			Process data only during designing, doesn't process during final export. Example: Monitor, Vectorscope 
	//FLAG_LONGPROCESS			Process that takes > 1s to finish. Long Process will display the Progress dialog and will prevent user from changing values during the process.
	//FLAG_NEEDSIZEDATA		    Process need to know size of original image, the zoom and what part of image is visible in the preview. When set the plugin will receive SetSizeData
	//FLAG_NEEDMOUSE			Process will receive Mouse respond data from the workplace. This is only if your object is interactive, for example Knob, Slider

	int GetFlags ()
	{
		// it is fast process
		int nFlag = FLAG_NONE;

		return nFlag;
	}


	// User Interface Build
	// there is maximum 29 Parameters

	int GetUIParameters (UIParameters* pParameters)
	{
		// label, value, min, max, type_of_control, special_value
		// use the UI builder in the software to generate this

		AddParameter( PARAM_WHITEBALANCE ,"Histogram Stretch|RGB Brightest Pixel|RGB Grey World|RGB Modified Grey|LMS Grey World (Experiment)|XYZ D50 Grey World(Exper.)|XYZ D65 Grey World(Exper.)|CIE RGB XYZ(Experiment)", 0, 0, 7, TYPE_ONEOFMANY, 0);

		return NUMBER_OF_USER_PARAMS;
	}
	

	// Actual processing function for 1 input
	//***************************************************************************************************
	// Both buffers are the same size
	// don't change the IN buffer or things will go bad for other objects in random fashion
	// the pBGRA_out comes already with pre-copied data from pBGRA_in
	// Note: Don't assume the nWidth and nHeight will be every run the same or that it contains the whole image!!!! 
	// This function receives buffer of the actual preview (it can be just a crop of image when zoomed in) and during the final calculation of the full buffer
	virtual void Process_Data (BYTE* pBGRA_out,BYTE* pBGRA_in, int nWidth, int nHeight, UIParameters* pParameters)
	{
		// Get the latest parameters

		// This routine will seem complex, but only because  we are using different appoaches to white balance
		// all of the routines have to gather various stats about the image.

		//List of Parameters
		int nWhiteBalance = (int)GetValue(PARAM_WHITEBALANCE);

		int colorspace = 255;//used for interger, this is the color space 0-255
		double f_colorspace = 255.0;//used for floats, this is the color space 0-255
		int halfcolorspace = 127;
		double f_halfcolorspace = 127.5;//half the range of color space



		if (nWhiteBalance == 0)
			//Histogram Stretch
			// This is one of the classic white balance routines
			// Histogram stretch finds the darkest pixel and lightest pixel and stretches the range from 0-255. 
			//So lets say your darkest pixel is 25 and brightest is 230, this routine will stretch it to the darkest 
			//being 0 and the brightest being 255, the theory is that will shift the colors in the correct range, 
			//it has many faults, such as, what if the range is already stretched,
			//but it is generic and common enough that it should be included. It works in RGB color space.
		{

			////////////////// MAX
			int maximumred = 0;
			int maximumgreen = 0;
			int maximumblue = 0;

			////////////////// MIN
			int minimumred = 65535;
			int minimumgreen = 65535;
			int minimumblue = 65535;

			///////////////// to prevent going above colorspace
			int rr;
			int gg;
			int bb;

			// lets collect some stats, we can collect these in int format
			// we are looking for the maximum and minimum pixel
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{				
					int nIdx = x*4+y*4*nWidth;
				
					int red = pBGRA_in[nIdx+CHANNEL_R];
					int green = pBGRA_in[nIdx+CHANNEL_G];
					int blue = pBGRA_in[nIdx+CHANNEL_B];

					//find max
					if (red > maximumred) {maximumred = red;}
					if (green > maximumgreen){maximumgreen = green;}
					if (blue > maximumblue){maximumblue = blue;}

					//find min
					if (red < minimumred){minimumred = red;}
					if (green < minimumgreen){minimumgreen = green;}
					if (blue < minimumblue){minimumblue = blue;}
				}
			}

			// lets stretch that histogram
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{				
					int nIdx = x*4+y*4*nWidth;
				
					int red = pBGRA_in[nIdx+CHANNEL_R];
					int green = pBGRA_in[nIdx+CHANNEL_G];
					int blue = pBGRA_in[nIdx+CHANNEL_B];


					// clipping max value if over 255
					// This area would need to be modified if Photo-Reactor started supporting 16 bit per pixel color resolution
					// you could use the built in CLAMP255, but if you felt like rewiting the CLAMP function, here's how you would do it.
					rr = (red - minimumred) * (colorspace) / (maximumred - minimumred) + 1;
					if (rr > colorspace) { rr = colorspace;}

					gg = (green - minimumgreen) * (colorspace) / (maximumgreen - minimumgreen) + 1;
					if (gg > colorspace) { gg = colorspace;}

					bb = (blue - minimumblue) * (colorspace) / (maximumblue - minimumblue) + 1;
					if (bb > colorspace) { bb = colorspace;}

					pBGRA_out[nIdx+CHANNEL_R] = rr;
					pBGRA_out[nIdx+CHANNEL_G] = gg;
					pBGRA_out[nIdx+CHANNEL_B] = bb;
				}
			}
		}

		if (nWhiteBalance == 1)
		//white pixel
		// this routine assume the brightest pixel in the image is white,
		// and adjust the remainer of the pixels as if there was white
		// there are  problems if there is no white in the image
		// this routine has limited uses, however it is here for educational purposes
		//first we need to collect some stats on the image first, 
		//in this case we need to find the brightst pixel in each channel
		// R G B
		{
			float red = 0.0;
			float green = 0.0;
			float blue = 0.0;

			////////////////// MAX
			float maxred = 0.0;
			float maxgreen = 0.0;
			float maxblue = 0.0;

			int maximumred;
			int maximumgreen;
			int maximumblue;

			//This is to just gather some stats on the image, we will be working in the 0-1 space floating point
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
					int nIdx = x*4+y*4*nWidth;

					//normalize to 0 - 1
					{
						red =   float(pBGRA_in[nIdx+CHANNEL_R] / f_colorspace);
						green = float(pBGRA_in[nIdx+CHANNEL_G] / f_colorspace);
						blue =  float(pBGRA_in[nIdx+CHANNEL_B] / f_colorspace);
					}

					//to find max brightness in each color
					{
						if (red > maxred) { maxred = red; }
						if (green > maxgreen) { maxgreen = green; }
						if (blue > maxblue) { maxblue = blue; }
					}
				}
			}

			maximumred = maxred * f_colorspace;
			maximumgreen = maxgreen * f_colorspace;
			maximumblue = maxblue * f_colorspace;

			// at this point we know what the brightest pixels are in each of R G B
			// now we need to stretch using the max of each as the stretching point

			//now lets cycle throught each pixel again, knowing what the max pixel is of each RGB
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
					int nIdx = x*4+y*4*nWidth;

					//normalize to 0 - 1
					{
						red =   float(pBGRA_in[nIdx+CHANNEL_R] / f_colorspace);
						green = float(pBGRA_in[nIdx+CHANNEL_G] / f_colorspace);
						blue =  float(pBGRA_in[nIdx+CHANNEL_B] / f_colorspace);
					}
					
					// brightest pixel formula
					red = red * 1 / maxred;
					green = green * 1 / maxgreen;
					blue = blue * 1 / maxblue;

					maximumred =   (int)(red   * f_colorspace);
					maximumgreen = (int)(green * f_colorspace);
					maximumblue =  (int)(blue  * f_colorspace);

					// clipping max value if over 255
					// This area would need to be modified if Photo-Reactor started supporting 16 bit per pixel color resolution
					// you could use the built in CLAMP255, but if you felt like rewiting the CLAMP functino, here's how you would do it.					
					if (maximumred > colorspace) { maximumred = colorspace;}
					if (maximumgreen > colorspace) { maximumgreen = colorspace;}
					if (maximumblue > colorspace) { maximumblue = colorspace;}

					pBGRA_out[nIdx+CHANNEL_R] = maximumred;
					pBGRA_out[nIdx+CHANNEL_G] = maximumgreen;
					pBGRA_out[nIdx+CHANNEL_B] = maximumblue;
				}
			}
		}//end routine 1

		if (nWhiteBalance == 2)
		//Grey World
		//Grey World is based on the assumption that all colors in summation of the image should be grey. 
		//This is like mixing all the paints on an artist pallet and you should get grey, 
		//or 1/2 way between white and black is grey (128). 
		//It will shift the colors accordingly to make sure that the center of all colors combined is grey.
		//It fails if there are large areas of a single color, i.e. off colored blue sky, 
		//off colored large object of any type. It works in RGB color space.
		{
			float redpixel = 0.0;
			float greenpixel = 0.0;
			float bluepixel = 0.0;

			float red = 0.0;
			float green = 0.0;
			float blue = 0.0;

			float redcount = 0.0;
			float greencount = 0.0;
			float bluecount = 0.0;

			float normalizedred = 0.0;
			float normalizedgreen = 0.0;
			float normalizedblue = 0.0;

			int meanr;
			int meang;
			int meanb;

			int gwred;
			int gwgreen;
			int gwblue;;

			// THIS routine is just to determine stats
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
				
					int nIdx = x*4+y*4*nWidth;

					//normalize to 0 - 1 to find average
					{
						redpixel = pBGRA_in[nIdx+CHANNEL_R] / f_colorspace;
						greenpixel = pBGRA_in[nIdx+CHANNEL_G] / f_colorspace;
						bluepixel = pBGRA_in[nIdx+CHANNEL_B] / f_colorspace;
					}

					//lets collect a running average
					{
						red = red + redpixel;
						green = green + greenpixel;
						blue = blue + bluepixel;
					}

					redcount ++;
					greencount ++;
					bluecount ++;
				}
			}

			normalizedred = red/redcount;
			normalizedgreen = green/greencount;
			normalizedblue = blue/bluecount;

			redpixel = 0.0;
			greenpixel = 0.0;
			bluepixel = 0.0;

			// fractional division in 0-1 space throws off grey world, so lets stretch those values out to the 0-255 range.
			meanr = int(normalizedred * f_colorspace);
			meang = int(normalizedgreen * f_colorspace);
			meanb = int(normalizedblue * f_colorspace);
				
			//now lets cycle throught each pixel again, knowing what the max pixel is of each RGB
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
					int nIdx = x*4+y*4*nWidth;

					//read in the pixels
					gwred = pBGRA_in[nIdx+CHANNEL_R] * halfcolorspace / meanr;
					gwgreen = pBGRA_in[nIdx+CHANNEL_G] * halfcolorspace / meang;
					gwblue = pBGRA_in[nIdx+CHANNEL_B] * halfcolorspace / meanb;

					//This is my clamping routine, keeps everything below 255 and above 0
					// This area would need to be modified if Photo-Reactor started supporting 16 bit per pixel color resolution
					// you could use the built in CLAMP255, but if you felt like rewiting the CLAMP function, here's how you would do it.
					if (gwred > colorspace) {gwred = colorspace;}
					if (gwgreen > colorspace) {gwgreen  =colorspace;}
					if (gwblue > colorspace) {gwblue = colorspace;}

					if (gwred < 0) {gwred = 0;}
					if (gwgreen < 0) {gwgreen = 0;}
					if (gwblue < 0) {gwblue = 0;}

					pBGRA_out[nIdx+CHANNEL_R] = gwred;
					pBGRA_out[nIdx+CHANNEL_G] = gwgreen;
					pBGRA_out[nIdx+CHANNEL_B] = gwblue;
				}
			}
		}

		if (nWhiteBalance == 3)
		//Modified Grey World
		// This routine works very simular to the Standard Grey World Routine
		// The difference is how it calculates Grey.  It does this by calculating the average
		// of all the colors instead of assuming that Grey is 128.  This way it is hoped that large
		//objects do not influence the overall balance of the image.
		{
			float redpixel   = 0.0;
			float greenpixel = 0.0;
			float bluepixel  = 0.0;

			float red   = 0.0;
			float green = 0.0;
			float blue  = 0.0;

			float redcount   = 0.0;
			float greencount = 0.0;
			float bluecount  = 0.0;

			float normalizedred   = 0.0;
			float normalizedgreen = 0.0;
			float normalizedblue  = 0.0;

			int meanr;
			int meang;
			int meanb;

			int meanrgb;

			int gwred;
			int gwgreen;
			int gwblue;


			// THIS routine is just to determine stats
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
					int nIdx = x*4+y*4*nWidth;

					//normalize to 0 - 1 to find average
					{
						redpixel   = pBGRA_in[nIdx+CHANNEL_R] / f_colorspace;
						greenpixel = pBGRA_in[nIdx+CHANNEL_G] / f_colorspace;
						bluepixel  = pBGRA_in[nIdx+CHANNEL_B] / f_colorspace;
					}

					//lets collect a running average
					{
						red   = red   + redpixel;
						green = green + greenpixel;
						blue  = blue  + bluepixel;
					}

					redcount ++;
					greencount ++;
					bluecount ++;
				}
			}

			normalizedred   = red/redcount;
			normalizedgreen = green/greencount;
			normalizedblue  = blue/bluecount;

			redpixel   = 0.0;
			greenpixel = 0.0;
			bluepixel  = 0.0;

			// fractional division in 0-1 space throws off grey world, so lets stretch those values out to the 0-255 range.
			meanr = int(normalizedred   * f_colorspace);
			meang = int(normalizedgreen * f_colorspace);
			meanb = int(normalizedblue  * f_colorspace);

			meanrgb = (meanr + meang + meanb) / 3;				

			//now lets cycle throught each pixel again, knowing what the max pixel is of each RGB
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
					int nIdx = x*4+y*4*nWidth;

					gwred = pBGRA_in[nIdx+CHANNEL_R]   * meanrgb / meanr;
					gwgreen = pBGRA_in[nIdx+CHANNEL_G] * meanrgb / meang;
					gwblue = pBGRA_in[nIdx+CHANNEL_B]  * meanrgb / meanb;

					if (gwred   > colorspace){gwred   = colorspace;}
					if (gwgreen > colorspace){gwgreen = colorspace;}
					if (gwblue  > colorspace){gwblue  = colorspace;}

					if (gwred   < 0){gwred   = 0;}
					if (gwgreen < 0){gwgreen = 0;}
					if (gwblue  < 0){gwblue  = 0;}
					
					pBGRA_out[nIdx+CHANNEL_R] = gwred;
					pBGRA_out[nIdx+CHANNEL_G] = gwgreen;
					pBGRA_out[nIdx+CHANNEL_B] = gwblue;
				}
			}
		}

		//The next 4 routines are the Experimantal Routines

		if (nWhiteBalance == 4)//LMS Grey World
		//This routine works off of the same basis as the RGB Grey World with one exception,
		//it works in the LMS color Space
		{
			float redpixel = 0.0;
			float greenpixel = 0.0;
			float bluepixel = 0.0;

			float redcount = 0.0;
			float greencount = 0.0;
			float bluecount = 0.0;

			float normalizedred = 0.0;
			float normalizedgreen = 0.0;
			float normalizedblue = 0.0;

			int meanL;
			int meanM;
			int meanS;

			int meanlms;

			float red = 0.0;
			float green = 0.0;
			float blue = 0.0;

			float temp_red;
			float temp_green;
			float temp_blue;

			float luma = 0;

			int luminance = 0;

			float LMSL;//LMS Long Wave
			float LMSM;//LMS Medium Wave
			float LMSS;//LMS Short Wave

			int gwL = 0;
			int gwM = 0;
			int gwS = 0;

			// THIS routine is just to determine stats
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{				
					int nIdx = x*4+y*4*nWidth;

					//normalize to 0 - 1 to find average
					{
						redpixel = pBGRA_in[nIdx+CHANNEL_R] / f_colorspace;
						greenpixel = pBGRA_in[nIdx+CHANNEL_G] / f_colorspace;
						bluepixel = pBGRA_in[nIdx+CHANNEL_B] / f_colorspace;
					}

					// convert to LMS space to gather stats
					//http://www.cs.bris.ac.uk/~reinhard/papers/colourtransfer.pdf
					LMSL = (0.3811 * redpixel) + (0.5783 * greenpixel) + (0.0402 * bluepixel);
					LMSM = (0.1967 * redpixel) + (0.7244 * greenpixel) + (0.0782 * bluepixel);
					LMSS = (0.0241 * redpixel) + (0.1288 * greenpixel) + (0.8444 * bluepixel);

					//lets collect a running average
					{
						red = red + LMSL;
						green = green + LMSM;
						blue = blue + LMSS;
					}

					redcount ++;
					greencount ++;
					bluecount ++;
				}
			}

			normalizedred = red/redcount;
			normalizedgreen = green/greencount;
			normalizedblue = blue/bluecount;

			redpixel = 0.0;
			greenpixel = 0.0;
			bluepixel = 0.0;

			// fractional division in 0-1 space throws off grey world, so lets stretch those values out to the 0-255 range.
			meanL = (int) (normalizedred * f_colorspace);
			meanM = (int) (normalizedgreen * f_colorspace);
			meanS = (int) (normalizedblue * f_colorspace);

			meanlms = (meanL + meanM + meanS) / 3;

			//now lets cycle throught each pixel again, knowing what the average pixel is of each LMS
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{				
					int nIdx = x*4+y*4*nWidth;

					// work in 0-1				
					red = ((float) pBGRA_in[nIdx+CHANNEL_R] / f_colorspace);
					green = ((float) pBGRA_in[nIdx+CHANNEL_G] / f_colorspace);
					blue = ((float) pBGRA_in[nIdx+CHANNEL_B] / f_colorspace);

					//convert to LMS from RGB according to Reinhart
					//http://www.cs.bris.ac.uk/~reinhard/papers/colourtransfer.pdf
					LMSL = (0.3811 * red) + (0.5783 * green) + (0.0402 * blue);
					LMSM = (0.1967 * red) + (0.7244 * green) + (0.0782 * blue);
					LMSS = (0.0241 * red) + (0.1288 * green) + (0.8444 * blue);

					//lets normalize to interger since grey world values are off with 0-1 floating point range
					int LMS_L = (int)(LMSL * f_colorspace);
					int LMS_M = (int)(LMSM * f_colorspace);
					int LMS_S = (int)(LMSS * f_colorspace);

					// perform grey world here
					gwL = LMS_L * halfcolorspace / meanL;
					gwM = LMS_M * halfcolorspace / meanM;
					gwS = LMS_S * halfcolorspace / meanS;					

					//back down to 0-1 space so tranformation matrix works
					LMSL =  ((float)gwL / colorspace);
					LMSM =  ((float)gwM / colorspace);
					LMSS =  ((float)gwS / colorspace);

					//convert from LMS to RGB
					temp_red = (4.4679 * LMSL) + (-3.5873 * LMSM) + (0.1193 * LMSS);
					temp_green = (-1.2186 * LMSL) + (2.3809 * LMSM) + (-0.1624 * LMSS);
					temp_blue = (0.0497 * LMSL) + (-0.2439 * LMSM) + (1.2045 * LMSS);	

					gwL = ((int)(temp_red * f_colorspace));
					gwM = ((int)(temp_green * f_colorspace));
					gwS = ((int)(temp_blue * f_colorspace));

					if (gwL > colorspace){gwL = colorspace;}
					if (gwM > colorspace){gwM = colorspace;}
					if (gwS > colorspace){gwS = colorspace;}

					if (gwL < 0){gwL = 0;}
					if (gwM < 0){gwM = 0;}
					if (gwS < 0){gwS = 0;}

					pBGRA_out[nIdx+CHANNEL_R] = gwL;
					pBGRA_out[nIdx+CHANNEL_G] = gwM;
					pBGRA_out[nIdx+CHANNEL_B] = gwS;
				}			
			}
		}

		if (nWhiteBalance == 5)//XYZ D50 Grey World
		//This routine works off of the same basis as the RGB Grey World with one exception,
		//it works in the XYZ D50 color Space
		{
			float redpixel = 0.0;
			float greenpixel = 0.0;
			float bluepixel = 0.0;

			float redcount = 0.0;
			float greencount = 0.0;
			float bluecount = 0.0;

			float normalizedred = 0.0;
			float normalizedgreen = 0.0;
			float normalizedblue = 0.0;

			int meanX;
			int meanY;
			int meanZ;

			float red = 0.0;
			float green = 0.0;
			float blue = 0.0;

			float temp_red;
			float temp_green;
			float temp_blue;

			float luma = 0;

			int luminance = 0;

			float xxx;
			float yyy;
			float zzz;

			int gwX = 0;
			int gwY = 0;
			int gwZ = 0;

			// THIS routine is just to determine stats
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
				
					int nIdx = x*4+y*4*nWidth;
										

					//normalize to 0 - 1 to find average
					{
						redpixel = pBGRA_in[nIdx+CHANNEL_R] / f_colorspace;
						greenpixel = pBGRA_in[nIdx+CHANNEL_G] / f_colorspace;
						bluepixel = pBGRA_in[nIdx+CHANNEL_B] / f_colorspace;
					}

					// convert to D50 XYZ space to gather stats					
					xxx = (0.4360747 * redpixel) + (0.3850649 * greenpixel) + (0.1430804 * bluepixel);
					yyy = (0.2225045 * redpixel) + (0.7168786 * greenpixel) + (0.0606169 * bluepixel);
					zzz = (0.0139322 * redpixel) + (0.0971045 * greenpixel) + (0.7141733 * bluepixel);
					
					//lets collect a running average
					{
						red = red + xxx;
						green = green + yyy;
						blue = blue + zzz;
					}

					redcount ++;
					greencount ++;
					bluecount ++;
				}
			}

			normalizedred = red/redcount;
			normalizedgreen = green/greencount;
			normalizedblue = blue/bluecount;

			redpixel = 0.0;
			greenpixel = 0.0;
			bluepixel = 0.0;

			// fractional division in 0-1 space throws off grey world, so lets stretch those values out to the 0-255 range.
			meanX = (int) (normalizedred * f_colorspace);
			meanY = (int) (normalizedgreen * f_colorspace);
			meanZ = (int) (normalizedblue * f_colorspace);

			//now lets cycle throught each pixel again, knowing what the average pixel is of each LMS
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{				
					int nIdx = x*4+y*4*nWidth;

					// work in 0-1				
					redpixel = ((float) pBGRA_in[nIdx+CHANNEL_R] / f_colorspace);
					greenpixel = ((float) pBGRA_in[nIdx+CHANNEL_G] / f_colorspace);
					bluepixel = ((float) pBGRA_in[nIdx+CHANNEL_B] / f_colorspace);

					// convert to D50 XYZ space to gather stats					
					xxx = (0.4360747 * redpixel) + (0.3850649 * greenpixel) + (0.1430804 * bluepixel);
					yyy = (0.2225045 * redpixel) + (0.7168786 * greenpixel) + (0.0606169 * bluepixel);
					zzz = (0.0139322 * redpixel) + (0.0971045 * greenpixel) + (0.7141733 * bluepixel);

					//lets normalize to interger since grey world values are off with 0-1 floating point range
					int XXX = (int)(xxx * f_colorspace);
					int YYY = (int)(yyy * f_colorspace);
					int ZZZ = (int)(zzz * f_colorspace);

					// perform grey world here
					gwX = XXX * halfcolorspace / meanX;
					gwY = YYY * halfcolorspace / meanY;
					gwZ = ZZZ * halfcolorspace / meanZ;	

					//back down to 0-1 space so tranformation matrix works
					xxx =  ((float)gwX / colorspace);
					yyy =  ((float)gwY / colorspace);
					zzz =  ((float)gwZ / colorspace);

					//convert from XYZ to RGB
					temp_red =   (3.13385610 * xxx) + (-1.6168667 * yyy) + (-0.4906146 * zzz);
					temp_green = (-0.9787684 * xxx) + (1.9161415  * yyy) + (0.0334540  * zzz);
					temp_blue =  (0.07194530 * xxx) + (-0.2289914 * yyy) + (1.4052427  * zzz);
		
					gwX = ((int)(temp_red * f_colorspace));
					gwY = ((int)(temp_green * f_colorspace));
					gwZ = ((int)(temp_blue * f_colorspace));

					if (gwX > colorspace){gwX = colorspace;}
					if (gwY > colorspace){gwY = colorspace;}
					if (gwZ > colorspace){gwZ = colorspace;}

					if (gwX < 0){gwX = 0;}
					if (gwY < 0){gwY = 0;}
					if (gwZ < 0){gwZ = 0;}

					pBGRA_out[nIdx+CHANNEL_R] = gwX;
					pBGRA_out[nIdx+CHANNEL_G] = gwY;
					pBGRA_out[nIdx+CHANNEL_B] = gwZ;
				}			
			}
		}
		
		if (nWhiteBalance == 6)//XYZ D65 Grey World
		//This routine works off of the same basis as the RGB Grey World with one exception,
		//it works in the XYZ D65 color Space
		{

			float redpixel = 0.0;
			float greenpixel = 0.0;
			float bluepixel = 0.0;

			float redcount = 0.0;
			float greencount = 0.0;
			float bluecount = 0.0;

			float normalizedred = 0.0;
			float normalizedgreen = 0.0;
			float normalizedblue = 0.0;

			int meanX;
			int meanY;
			int meanZ;

			float red = 0.0;
			float green = 0.0;
			float blue = 0.0;

			float temp_red;
			float temp_green;
			float temp_blue;

			float luma = 0;

			int luminance = 0;

			float xxx;
			float yyy;
			float zzz;

			int gwX = 0;
			int gwY = 0;
			int gwZ = 0;

			// THIS routine is just to determine stats
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{				
					int nIdx = x*4+y*4*nWidth;

					//normalize to 0 - 1 to find average
					{
						redpixel = pBGRA_in[nIdx+CHANNEL_R] / f_colorspace;
						greenpixel = pBGRA_in[nIdx+CHANNEL_G] / f_colorspace;
						bluepixel = pBGRA_in[nIdx+CHANNEL_B] / f_colorspace;
					}

					// convert to D65 XYZ space to gather stats					
					xxx = (0.4124564 * redpixel) + (0.3575761 * greenpixel) + (0.1804375 * bluepixel);
					yyy = (0.2126729 * redpixel) + (0.7151522 * greenpixel) + (0.0721750 * bluepixel);
					zzz = (0.0193339 * redpixel) + (0.1191920 * greenpixel) + (0.9503041 * bluepixel);
					
					//lets collect a running average
					{
						red = red + xxx;
						green = green + yyy;
						blue = blue + zzz;
					}

					redcount ++;
					greencount ++;
					bluecount ++;
				}
			}

			normalizedred = red/redcount;
			normalizedgreen = green/greencount;
			normalizedblue = blue/bluecount;

			redpixel = 0.0;
			greenpixel = 0.0;
			bluepixel = 0.0;

			// fractional division in 0-1 space throws off grey world, so lets stretch those values out to the 0-255 range.
			meanX = (int) (normalizedred * f_colorspace);
			meanY = (int) (normalizedgreen * f_colorspace);
			meanZ = (int) (normalizedblue * f_colorspace);

			//now lets cycle throught each pixel again, knowing what the average pixel is of each XYZ
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
				
					int nIdx = x*4+y*4*nWidth;

					// work in 0-1				
					redpixel = ((float) pBGRA_in[nIdx+CHANNEL_R] / f_colorspace);
					greenpixel = ((float) pBGRA_in[nIdx+CHANNEL_G] / f_colorspace);
					bluepixel = ((float) pBGRA_in[nIdx+CHANNEL_B] / f_colorspace);

					// convert to D65 XYZ space to gather stats					
					xxx = (0.4124564 * redpixel) + (0.3575761 * greenpixel) + (0.1804375 * bluepixel);
					yyy = (0.2126729 * redpixel) + (0.7151522 * greenpixel) + (0.0721750 * bluepixel);
					zzz = (0.0193339 * redpixel) + (0.1191920 * greenpixel) + (0.9503041 * bluepixel);

					//lets normalize to interger since grey world values are off with 0-1 floating point range
					int XXX = (int)(xxx * f_colorspace);
					int YYY = (int)(yyy * f_colorspace);
					int ZZZ = (int)(zzz * f_colorspace);

					// perform grey world here
					gwX = XXX * halfcolorspace / meanX;
					gwY = YYY * halfcolorspace / meanY;
					gwZ = ZZZ * halfcolorspace / meanZ;

					//back down to 0-1 space so tranformation matrix works
					xxx =  ((float)gwX / colorspace);
					yyy =  ((float)gwY / colorspace);
					zzz =  ((float)gwZ / colorspace);

					//convert from XYZ D65 to RGB
					temp_red =   (3.2404542  * xxx) + (-1.5371385 * yyy) + (-0.4985314 * zzz);
					temp_green = (-0.9692660 * xxx) + (1.8760108  * yyy) + (0.0415560  * zzz);
					temp_blue =  (0.0556434  * xxx) + (-0.2040259 * yyy) + (1.0572252  * zzz);

					gwX = ((int)(temp_red * f_colorspace));
					gwY = ((int)(temp_green * f_colorspace));
					gwZ = ((int)(temp_blue * f_colorspace));

					if (gwX > colorspace){gwX = colorspace;}
					if (gwY > colorspace){gwY = colorspace;}
					if (gwZ > colorspace){gwZ = colorspace;}

					if (gwX < 0){gwX = 0;}
					if (gwY < 0){gwY = 0;}
					if (gwZ < 0){gwZ = 0;}

					pBGRA_out[nIdx+CHANNEL_R] = gwX;
					pBGRA_out[nIdx+CHANNEL_G] = gwY;
					pBGRA_out[nIdx+CHANNEL_B] = gwZ;
				}			
			}
		}

		if (nWhiteBalance == 7)//CIE RGB XYZ Grey World
		// this routine like the ones above work simular in Grey World except instead of sRGB uses CIE RGB D50
		{
			float redpixel = 0.0;
			float greenpixel = 0.0;
			float bluepixel = 0.0;

			float redcount = 0.0;
			float greencount = 0.0;
			float bluecount = 0.0;

			float normalizedred = 0.0;
			float normalizedgreen = 0.0;
			float normalizedblue = 0.0;

			int meanX;
			int meanY;
			int meanZ;

			float red = 0.0;
			float green = 0.0;
			float blue = 0.0;

			float temp_red;
			float temp_green;
			float temp_blue;

			float luma = 0;

			int luminance = 0;

			float xxx;
			float yyy;
			float zzz;

			int gwX = 0;
			int gwY = 0;
			int gwZ = 0;

			float rgamma;
			float ggamma;
			float bgamma;

			// THIS routine is just to determine stats
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{				
					int nIdx = x*4+y*4*nWidth;										

					//normalize to 0 - 1 to find average
					{
						redpixel = pBGRA_in[nIdx+CHANNEL_R] / f_colorspace;
						greenpixel = pBGRA_in[nIdx+CHANNEL_G] / f_colorspace;
						bluepixel = pBGRA_in[nIdx+CHANNEL_B] / f_colorspace;
					}

					//convert sRGB to RGB
					{
						rgamma = pow (redpixel, 2.2f);
						ggamma = pow (greenpixel, 2.2f);
						bgamma = pow (bluepixel, 2.2f);
					}

					// convert to CIE RGB D50 space to gather stats					
					xxx = (0.4868870   * rgamma) + (0.3062984   * ggamma) + (0.1710347 * bgamma);
					yyy = (0.1746583   * rgamma) + (0.8247541   * ggamma) + (0.0005877 * bgamma);
					zzz = (0.0012563   * rgamma) + (0.0169832   * ggamma) + (0.8094831 * bgamma);
					
					//lets collect a running average
					{
						red = red + xxx;
						green = green + yyy;
						blue = blue + zzz;
					}

					redcount ++;
					greencount ++;
					bluecount ++;
				}
			}

			normalizedred = red/redcount;
			normalizedgreen = green/greencount;
			normalizedblue = blue/bluecount;

			redpixel = 0.0;
			greenpixel = 0.0;
			bluepixel = 0.0;

			// fractional division in 0-1 space throws off grey world, so lets stretch those values out to the 0-255 range.
			meanX = (int) (normalizedred * f_colorspace);
			meanY = (int) (normalizedgreen * f_colorspace);
			meanZ = (int) (normalizedblue * f_colorspace);

			//now lets cycle throught each pixel again, knowing what the average pixel is of each CIE RGB D50
			for (int y = 0; y< nHeight; y++)
			{
				for (int x = 0; x< nWidth; x++)
				{
				
					int nIdx = x*4+y*4*nWidth;

					// work in 0-1				
					redpixel   = ((float) pBGRA_in[nIdx+CHANNEL_R] / f_colorspace);
					greenpixel = ((float) pBGRA_in[nIdx+CHANNEL_G] / f_colorspace);
					bluepixel  = ((float) pBGRA_in[nIdx+CHANNEL_B] / f_colorspace);

					//convert sRGB to RGB
					{
						rgamma = pow (redpixel, 2.2f);
						ggamma = pow (greenpixel, 2.2f);
						bgamma = pow (bluepixel, 2.2f);
					}

					// convert to D50 CIE RGB space to gather stats					
					xxx = (0.4868870    * rgamma) + (0.3062984   * ggamma) + (0.1710347 * bgamma);
					yyy = (0.1746583    * rgamma) + (0.8247541   * ggamma) + (0.0005877 * bgamma);
					zzz = (-0.0012563   * rgamma) + (0.0169832   * ggamma) + (0.8094831 * bgamma);

					//lets normalize to interger since grey world values are off with 0-1 floating point range
					int XXX = (int)(xxx * f_colorspace);
					int YYY = (int)(yyy * f_colorspace);
					int ZZZ = (int)(zzz * f_colorspace);

					// perform grey world here
					gwX = XXX * halfcolorspace / meanX;
					gwY = YYY * halfcolorspace / meanY;
					gwZ = ZZZ * halfcolorspace / meanZ;

					//back down to 0-1 space so tranformation matrix works
					xxx =  ((float)gwX / colorspace);
					yyy =  ((float)gwY / colorspace);
					zzz =  ((float)gwZ / colorspace);

					//convert from CIE RGB to sRGB
					temp_red =   (2.3638081   * xxx) + (-0.8676030  * yyy) + (-0.4988161 * zzz);
					temp_green = (-0.5005940  * xxx) + (1.3962369  * yyy) + (0.1047562  * zzz);
					temp_blue =  (0.0141712   * xxx) + (-0.0306400 * yyy) + (1.2323842  * zzz);

					//from rgb to srgb
					{
						rgamma = pow( temp_red,(1/2.2f));
						ggamma = pow( temp_green,(1/2.2f));
						bgamma = pow( temp_blue,(1/2.2f));
					}
					
					gwX = ((int)(rgamma * f_colorspace));
					gwY = ((int)(ggamma * f_colorspace));
					gwZ = ((int)(bgamma * f_colorspace));

					if (gwX > colorspace){gwX = colorspace;}
					if (gwY > colorspace){gwY = colorspace;}
					if (gwZ > colorspace){gwZ = colorspace;}

					if (gwX < 0){gwX = 0;}
					if (gwY < 0){gwY = 0;}
					if (gwZ < 0){gwZ = 0;}

					pBGRA_out[nIdx+CHANNEL_R] = gwX;
					pBGRA_out[nIdx+CHANNEL_G] = gwY;
					pBGRA_out[nIdx+CHANNEL_B] = gwZ;
				}			
			}
		}

	}

	// actual processing function for 2 inputs
	//********************************************************************************
	// all buffers are the same size
	// don't change the IN buffers or things will go bad
	// the pBGRA_out comes already with copied data from pBGRA_in1
	virtual void Process_Data2 (BYTE* pBGRA_out, BYTE* pBGRA_in1, BYTE* pBGRA_in2, int nWidth, int nHeight, UIParameters* pParameters)
	{
		int nWhiteBalance = (int)GetValue(PARAM_WHITEBALANCE);
	}


	//*****************Drawing functions for the BOX *********************************
	//how is the drawing handled
	//DRAW_AUTOMATICALLY	the main program will fully take care of this and draw a box, title, socket and thumbnail
	//DRAW_SIMPLE_A			will draw a box, title and sockets and call CustomDraw
	//DRAW_SIMPLE_B			will draw a box and sockets and call CustomDraw
	//DRAW_SOCKETSONLY      will call CustomDraw and then draw sockets on top of it
	
	// highlighting rectangle around is always drawn except for DRAW_SOCKETSONLY

	virtual int GetDrawingType ()
	{
		int nType = DRAW_AUTOMATICALLY;

		return nType;
	}


	// Custom Drawing
	// custom drawing function called when drawing type is different than DRAW_AUTOMATICALLY
	// it is not always in real pixels but scaled depending on where it is drawn
	// the scale could be from 1.0 to > 1.0
	// so you always multiply the position, sizes, font size, line width with the scale
	
	virtual void CustomDraw (HDC hDC, int nX,int nY, int nWidth, int nHeight, float scale, BOOL bIsHighlighted, UIParameters* pParameters)
	{

	}


	//************ Optional Functions *****************************************************************************************
	// those functions are not necessary for normal effect, they are mostly for special effects and objects


	// Called when FLAG_HELPER set. 
	// When UI data changed (user turned knob) this function will be called as soon as user finish channging the data
	// You will get the latest parameters and also which parameter changed
	// Normally for effects you don't have to do anything here because you will get the same parameters in the process function
	// It is only for helper objects that may not go to Process Data 
	BOOL UIParametersChanged (UIParameters* pParameters, int nParameter)
	{		
		return FALSE;
	}

	// when button is pressed on UI, this function will be called with the parameter and sub button (for multi button line)
	BOOL UIButtonPushed (int nParam, int nSubButton, UIParameters* pParameters)
	{
		return TRUE;
	}

	// Called when FLAG_NEEDSIZEDATA set
	// Called before each calculation (Process_Data)
	// If your process depends on a position on a frame you may need the data to correctly display it because Process_Data receives only a preview crop
	// Most normal effects don't depend on the position in frame so you don't need the data
	// Example: drawing a circle at a certain position requires to know what is displayed in preview or the circle will be at the same size and position regardless of zoom
	
	// Note: Even if you need position but you don't want to mess with the crop data, just ignore it and pretend the Process_Data are always of full image (they are not). 
	// In worst case this affects only preview when using zoom. The full process image always sends the whole data

	// nOriginalW, nOriginalH - the size of the original - full image. If user sets Resize on input - this will be the resized image
	// nPreviewW, nPreviewH   - this is the currently processed preview width/height - it is the same that Process_Data will receive
	//                        - in full process the nPreviewW, nPreviewH is equal nOriginalW, nOriginalH
	// Crop X1,Y1,X2,Y2       - relative coordinates of preview crop rectangle in <0...1>, for full process they are 0,0,1,1 (full rectangle)	
	// dZoom                  - Zoom of the Preview, for full process the dZoom = 1.0
	void SetSizeData(int nOriginalW, int nOriginalH, int nPreviewW, int nPreviewH, double dCropX1, double dCropY1, double dCropX2, double dCropY2, double dZoom)
	{

		// so if you need the position and zoom, this is the place to get it.
		// Note: because of IBM wisdom the internal bitmaps are on PC always upside down, but the coordinates are not
		// which you  need to take into account. See rectangle demo project for more info 


	}


	// ***** Mouse handling on workplace *************************** 
	// only if FLAG_NEEDMOUSE is set
	//****************************************************************
	//this is for special objects that need to receive mouse, like a knob or slider on workplace
	// normally you use this for FLAG_BINDING objects

	// in coordinates relative to top, left corner of the object (0,0)
	virtual BOOL MouseButtonDown (int nX, int nY, int nWidth, int nHeight, UIParameters* pParameters)
	{
		// return FALSE if not handled
		// return TRUE if handled
		return FALSE;
	}

	// in coordinates relative to top, left corner of the object (0,0)
	virtual BOOL MouseMove (int nX, int nY, int nWidth, int nHeight, UIParameters* pParameters)
	{
	
		return FALSE;
	}
	
	// in coordinates relative to top, left corner of the object (0,0)
	virtual BOOL MouseButtonUp (int nX, int nY, int nWidth, int nHeight, UIParameters* pParameters)
	{
		
		// Note: if we changed data and need to recalculate the flow we need to return TRUE


		// return FALSE if not handled
		// return TRUE if handled
		
		return TRUE;
	}


};

extern "C"
{
	// Plugin factory function
	__declspec(dllexport) IPlugin* Create_Plugin ()
	{
		//allocate a new object and return it
		return new PluginTest ();
	}
	
	// Plugin cleanup function
	__declspec(dllexport) void Release_Plugin (IPlugin* p_plugin)
	{
		//we allocated in the factory with new, delete the passed object
		delete p_plugin;
	}
	
}


// this is the name that will appear in the object library
extern "C" __declspec(dllexport) char* GetPluginName()
{
	return "White Balance";	
}


// This MUST be unique string for each plugin so we can save the data

extern "C" __declspec(dllexport) char* GetPluginID()
{
	
// 	IMPORTANT:you have to fill unique ID for every plugin:
// 	The ID must be unique or loading and saving will not be able to find correct plugin
//  Comment out this line below so you can compile
//	ATTENTION

	return "com.lumafilters.WhiteBalance";	
}


// category of plugin, for now the EFFECT go to top library box, everything else goes to the middle library box
extern "C" __declspec(dllexport) int GetCategory()
{
		
	return CATEGORY_EFFECT;
	
}

